/****************************************************************************
 *
 * Project: Olimex ARM JTAG.
 *
 * Copyright by Olimex Ltd. All rights reserved.
 *
 * File: testmenu.h
 * Description: Extremely simple terminal UI for accessing test functions.
 * Developer: Dimitar Dimitrov ( dinuxbg,gmail.com )
 *
 * Last change: $Date$
 * Revision: $Revision: 29 $
 * Id: $Id$
 *
 ****************************************************************************/

#ifndef TESTMENU_H
#define TESTMENU_H

#include <stdint.h>
#include <stdbool.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifndef EIO
  #define EIO	5
#endif

typedef void (*testmenu_testfunc_t)(void);

struct testmenu_entry {
	const char *name;
	int (*test_func)(void);
};

struct testmenu {
	const struct testmenu_entry *entries;
	unsigned int num_entries;

	void (*puts)(const char *s);
	int (*getc)(void);
};

extern const struct testmenu testmenu_def;

void testmenu_poll(void);

#ifdef __cplusplus
}
#endif

#endif	/* TESTMENU_H */

